Overview | Package | Class | Tree | Deprecated | Index | Help
| Copyright 2012-04-26 Werner Randelshofer
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.monte.media.avi
Class ZMBVCodecCore

    java.lang.Object
      org.monte.media.avi.ZMBVCodecCore

    public class ZMBVCodecCore

extends java.lang.Object

Implements the DosBox Capture Codec `"ZMBV"`.

This is a codec added to the DosBox project to capture screen data (like Vmware VMNC).

This codec employs ZLIB compression and has intraframes and delta frames. Delta frames seem to have blocks either copied from the previous frame or XOR'ed with some block from the previous frame.

The FourCC for this codec is ZMBV which ostensibly stands for Zip Motion Blocks Video. The data is most commonly stored in AVI files.

Data Format

Byte 0 of a ZMBV data chunk contains the following flags:

     bits 7-2  undefined
     bit 1     palette change
     bit 0     1 = intraframe, 0 = interframe

If the frame is an intra frame as indicated by bit 0 of byte 0, the next 6 bytes in the data chunk are formatted as follows:

     byte 1    major version
     byte 2    minor version
     byte 3    compression type (0 = uncompressed, 1 = zlib-compressed)
     byte 4    video format
     byte 5    block width
     byte 6    block height

Presently, the only valid major/minor version pair is 0/1. A block width or height of 0 is invalid. These are the video modes presently defined:

     0  none
     1  1 bit/pixel, palettized
     2  2 bits/pixel, palettized
     3  4 bits/pixel, palettized
     4  8 bits/pixel, palettized
     5  15 bits/pixel
     6  16 bits/pixel
     7  24 bits/pixel
     8  32 bits/pixel

Presently, only modes 4 (8 bpp), 5 (15 bpp), 6 (16 bpp) and 8 (32 bpp) are supported.

If the compression type is 1, the remainder of the data chunk is compressed using the standard zlib package. Decompress the data before proceeding with the next step. Otherwise, proceed to the next step. Also note that you must reset zlib for intraframes.

If bit 1 of the frame header (palette change) is set then the first 768 bytes of the uncompressed data represent 256 red-green-blue palette triplets. Each component is one byte and ranges from 0..255.

An intraframe consists of 768 bytes of palette data (for palettized modes) and raw frame data.

An interframe is comprised of up to three parts:

1. if palette change flag was set then first 768 bytes represent XOR'ed palette difference
2. block info (2 bytes per block, padded to 4 bytes length)
3. block differences

Block info is composed from a motion vector and a flag: first byte is (dx << 1) | flag, second byte is (dy << 1). Motion vectors can go out of bounds and in that case you need to zero the out-of-bounds part. Also note that currently motion vectors are limited to a range of (-16..16). Flag tells whether the codec simply copies the block from the decoded offset or copies it and XOR's it with data from block differences. All XORing for 15/16 bpp and 32 bpp modes is done with little-endian integers.

Interframe decoding can be done this way:

     for each block {
       a = block_info[current_block][0];
       b = block_info[current_block][1];
       dx = a >> 1;
       dy = b >> 1;
       flag = a & 1;
       copy block from offset (dx, dy) from previous frame.
       if (flag) {
         XOR block with data read from stream.
       }
     }

References
http://wiki.multimedia.cx/index.php?title=ZMBV

Note: We use the JZLib library for decoding compressed input streams, because the `javax.zip.InflaterInputStream` sometimes fails to decode the data.

*

Version:
  1.0 2011-08-29 Created.
Author:
  Werner Randelshofer

Field Summary
`static int` | `COMPRESSION_NONE`
`static int` | `COMPRESSION_ZLIB`
`static int` | `VIDEOMODE_1_BIT_PALETTIZED`
`static int` | `VIDEOMODE_15_BIT_BGR`
`static int` | `VIDEOMODE_16_BIT_BGR`
`static int` | `VIDEOMODE_2_BIT_PALETTIZED`
`static int` | `VIDEOMODE_24_BIT_BGR`
`static int` | `VIDEOMODE_32_BIT_BGR`
`static int` | `VIDEOMODE_4_BIT_PALETTIZED`
`static int` | `VIDEOMODE_8_BIT_PALETTIZED`
`static int` | `VIDEOMODE_NONE`

Constructor Summary
`ZMBVCodecCore()`

Method Summary
`boolean` | `decode(byte[] inDat, int off, int length, byte[] outDat, byte[] prevDat, int width, int height, boolean onlyDecodeIfKeyframe)` Decodes to 8-bit palettised.
`boolean` | `decode(byte[] inDat, int off, int length, int[] outDat, int[] prevDat, int width, int height, boolean onlyDecodeIfKeyframe)` Decodes to 32-bit RGB.
`int` | `decode(byte[] inDat, int off, int length, java.lang.Object[] outDatHolder, java.lang.Object[] prevDatHolder, int width, int height, boolean onlyDecodeIfKeyframe)` Decodes to 8-bit, 15-bit, 16-bit or 32-bit RGB depending on input data.
`int[]` | `getPalette()`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### VIDEOMODE_NONE

    public static final int VIDEOMODE_NONE

See Also:
  Constant Field Values

### VIDEOMODE_1_BIT_PALETTIZED

    public static final int VIDEOMODE_1_BIT_PALETTIZED

See Also:
  Constant Field Values

### VIDEOMODE_2_BIT_PALETTIZED

    public static final int VIDEOMODE_2_BIT_PALETTIZED

See Also:
  Constant Field Values

### VIDEOMODE_4_BIT_PALETTIZED

    public static final int VIDEOMODE_4_BIT_PALETTIZED

See Also:
  Constant Field Values

### VIDEOMODE_8_BIT_PALETTIZED

    public static final int VIDEOMODE_8_BIT_PALETTIZED

See Also:
  Constant Field Values

### VIDEOMODE_15_BIT_BGR

    public static final int VIDEOMODE_15_BIT_BGR

See Also:
  Constant Field Values

### VIDEOMODE_16_BIT_BGR

    public static final int VIDEOMODE_16_BIT_BGR

See Also:
  Constant Field Values

### VIDEOMODE_24_BIT_BGR

    public static final int VIDEOMODE_24_BIT_BGR

See Also:
  Constant Field Values

### VIDEOMODE_32_BIT_BGR

    public static final int VIDEOMODE_32_BIT_BGR

See Also:
  Constant Field Values

### COMPRESSION_NONE

    public static final int COMPRESSION_NONE

See Also:
  Constant Field Values

### COMPRESSION_ZLIB

    public static final int COMPRESSION_ZLIB

See Also:
  Constant Field Values

Constructor Detail

### ZMBVCodecCore

    public ZMBVCodecCore()

Method Detail

### decode

    public boolean decode(byte[] inDat,
                          int off,
                          int length,
                          int[] outDat,
                          int[] prevDat,
                          int width,
                          int height,
                          boolean onlyDecodeIfKeyframe)

  Decodes to 32-bit RGB. Returns true if a key-frame was decoded.

### decode

    public boolean decode(byte[] inDat,
                          int off,
                          int length,
                          byte[] outDat,
                          byte[] prevDat,
                          int width,
                          int height,
                          boolean onlyDecodeIfKeyframe)

  Decodes to 8-bit palettised. Returns true if a key-frame was decoded.

### decode

    public int decode(byte[] inDat,
                      int off,
                      int length,
                      java.lang.Object[] outDatHolder,
                      java.lang.Object[] prevDatHolder,
                      int width,
                      int height,
                      boolean onlyDecodeIfKeyframe)

  Decodes to 8-bit, 15-bit, 16-bit or 32-bit RGB depending on input data. Returns the number of decoded bits. Returns a negative number if keyframe. Returns 0 in case of failure.

### getPalette

    public int[] getPalette()

Overview | Package | Class | Tree | Deprecated | Index | Help
| Copyright 2012-04-26 Werner Randelshofer
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD